<?php

require_once('lib/extra/mail.php');
$mail_senden = new send_smtp_mail();

class ANMELDEN{
	
	protected $uid;
	protected $ak;
	protected $werber;
	
	function anmelden_los(){
		global $datenbank,$error,$meldung;
		$this->pruef();
		if($error == 0){
			$this->escapen();
			$this->konto($_POST['password1']);
			$this->email();
			$this->user();
			$this->werber();
			$this->nickpage();
			$this->aktivierung();
			$this->ak_senden();
			if($error == 0){
				return true;
			}else{
				return false;
			}
		}
	}
	
	function escapen(){
		global $datenbank,$_POST;
		foreach($_POST AS $key => $value){
			$_POST[$key] = $datenbank->escape($value);
		}
	}
	
	function ak_senden(){
		global $mail_senden,$grundconfig,$_POST;
		$betreff = "Ihre Anmeldung auf ". $grundconfig->seitenname;
		$email_message = 'Hallo ' . $_POST['nickname'] . ',
    	Du hast Dich soeben erfolgreich bei ' . $grundconfig->seitenname . ' angemeldet.

    	Bitte aktiviere jetzt Deinen Account, klicke dazu bitte auf den
    	Aktivierungslink: ' . $grundconfig->domain . '/?content=/intern/aktivieren&ak=' . $this->ak . '

    	----------------------------------------------------------
    	Kontonummer: ' . $this->uid . '
    	Passwort: Ihnen bekannt*
    	----------------------------------------------------------

    	Nach der Aktivierung kannst Du dich sofort einloggen und bei
    	uns teilnehmen.

    	Mit freundlichen Grüßen
    	Das ' . $grundconfig->seitenname . ' Team
    	';
		$mail_senden->senden($_POST['emailadresse'],$betreff,$email_message);
	}
	
	function aktivierung(){
		global $datenbank;
		$this->ak = md5($this->uid . time() );
		$insert = array(
			"uid" => $this->uid,
			"ak" => $this->ak
		);
		$datenbank->insert(PREFIX . AKT , $insert);
	}
	
	function nickpage(){
		global $datenbank;
		$insert = array(
			"uid" => $this->uid
		);
		$datenbank->insert(PREFIX . NICKP, $insert);
	}
	
	function werber(){
		global $datenbank,$_POST,$_SESSION;
		$insert = array(
			"uid" => $this->uid,
			"werber" => $this->werber_select($_SESSION['werber']),
			"umsatz" => 0,
			"zuordnungszeit" => time()
		);
		$datenbank->insert(PREFIX . WERBER , $insert);
	}
	
	function user(){
		global $datenbank,$_POST;
		$insert = array(
			"uid" => $this->uid,
			"nickname" => $_POST['nickname'],
			"vorname" => $_POST['nickname'],
			"nachname" => $_POST['nickname'],
			"angemeldet_seit" => time(),
			"bdate" => $this->bdate($_POST['bdate'])
		);
		$datenbank->insert(PREFIX . USER , $insert);
	}
 
	function konto($pass){
		global $datenbank;
		$pw = pw_erstellen($pass);
		$datenbank->insert(PREFIX . KONTO, array("passwort" => $pw, "status" => 0));
		$this->uid = $datenbank->lastid();
	}
	
	function email(){
		global $datenbank;
		$insert = array(
			"uid" => $this->uid,
			"emailadresse" => $_POST['emailadresse'],
			"freigabe_fuer" => $_POST['newsletter']
		);
		$datenbank->insert(PREFIX . EMAIL , $insert);
	}
	
	function bdate($date){
		$explode = explode(".",$date,100);
		$bdate = mktime(0,0,0,$explode[1],$explode[0],$explode[2]);
		return $bdate;
	}
	function pruef(){
		global $_POST,$error,$meldung;
		if(empty($_POST['nachname'])){ $error = 1; $meldung .= ANMELDEN_NAME_FALSE;}
		if(empty($_POST['bdate'])){ $error = 1; $meldung .= ANMELDEN_GEB_FALSE;} 
		if(empty($_POST['vorname'])){ $error = 1; $meldung .= ANMELDEN_VORNAME_FALSE;}
		$this->mailadresse($_POST['emailadresse']);
		$this->nickname($_POST['nickname']);
		$this->pass($_POST['password1'],$_POST['password2']);
		if($_POST['agb'] != "ja"){ $error = 1; $meldung .= ANEMLDEN_AGB_FALSE; }
	}
	
	function mail_denied($mail){
		global $datenbank,$grundconfig,$error,$meldung;
		$denied = explode(';', $grundconfig->denied_domains);
		if($grundconfig->ip_erlaubt != ''){
			$ip_denied = explode(',', $pageconfig['ip_erlaubt']);
			if(!in_array(geoIP($ip),$ip_denied)){
				$error = 1;
				$meldung .= ANMELDEN_IP_FALSE;}
		}
		foreach ($denied AS $nr => $emaildomain){
			if (($nr < (count ($denied) - 2) || strlen ($emaildomain) >= 5) && strpos ($mail, $emaildomain) !== false){
				$error = 1;
				$meldung .= ANMELDEN_MAIL_ANBIETER_FALSE;
			}
		}
	}
	
	function mailadresse($mail){
		global $datenbank,$error,$meldung;
		if(!filter_var( $mail, FILTER_VALIDATE_EMAIL )) { $error = 1; $meldung .= ANMELDEN_EMAIL_FALSE;}
		$select = $datenbank->exists(PREFIX . EMAIL , 'emailadresse', array("emailadresse" => $datenbank->escape($mail)));
		if($select == true){
			$error = 1;
			$meldung .= ANMELDEN_MAIL_EXIST;
		}
		$this->mail_denied($mail);
	}
	
	function pass($pass1,$pass2){
		global $error,$meldung;
		if(empty($pass1)){ $error = 1; $meldung .= ANMELDEN_PASS1_FALSE;}
		if(empty($pass2)){ $error = 1; $meldung .= ANMELDEN_PASS2_FALSE;}
		if($pass1 != $pass2){ $error = 1; $meldung .= ANMELDEN_PASS_KONTROLLE_FALSE;}
		if(strlen($pass1) < 8){ $error = 1; $meldung .= ANMELDEN_PASS_SHORT; }
	}
	
	function nickname($nick){
		global $datenbank,$error,$meldung;
		if(empty($nick)){$error = 1; $meldung = ANMELDEN_NICKNAME_FALSE;}
		$select = $datenbank->exists(PREFIX . USER , 'nickname', array("nickname" => $datenbank->escape($nick)));
		if($select == true){
			$error = 1;
			$meldung .= ANMLEDEN_NICKNAME_EXIST;
		}
	}
	
	function werber_select($werber){
		global $datenbank;
		if($werber != ''){
			$ab = $datenbank->exists(PREFIX . USER , 'uid' , array("uid" => $datenbank->escape($werber)));
			if(!is_numeric($werber) OR $ab == false){
				$this->werber = 0;
			}
		}else{
			$this->werber = $werber;
		}
	}
}

?>